"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cyrb53 = void 0;
var cyrb53 = function (seed) {
    if (seed === void 0) { seed = 0; }
    return function (str) {
        var h1 = 0xdeadbeef ^ seed;
        var h2 = 0x41c6ce57 ^ seed;
        for (var i = 0, ch = void 0; i < str.length; i++) {
            ch = str.charCodeAt(i);
            h1 = Math.imul(h1 ^ ch, 2654435761);
            h2 = Math.imul(h2 ^ ch, 1597334677);
        }
        h1 = Math.imul(h1 ^ (h1 >>> 16), 2246822507) ^ Math.imul(h2 ^ (h2 >>> 13), 3266489909);
        h2 = Math.imul(h2 ^ (h2 >>> 16), 2246822507) ^ Math.imul(h1 ^ (h1 >>> 13), 3266489909);
        return 4294967296 * (2097151 & h2) + (h1 >>> 0);
    };
};
exports.cyrb53 = cyrb53;
