"use strict";
// null, string, number, bigint, undefined, boolean
Object.defineProperty(exports, "__esModule", { value: true });
var equals = function (self, other) {
    if (self === null || other === null)
        return self === other;
    if (typeof self !== typeof other)
        return false;
    if (Array.isArray(self) !== Array.isArray(other))
        return false;
    if (Array.isArray(self)) {
        if (self.length !== other.length)
            return false;
        for (var i = 0; i < self.length; i++) {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            var left = self[i];
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            var right = other[i];
            if (!equals(left, right))
                return false;
        }
        return true;
    }
    if (typeof self === 'object') {
        var selfValues = Object.entries(self);
        var otherValues = Object.entries(other);
        selfValues.sort(function (_a, _b) {
            var l = _a[0];
            var r = _b[0];
            return l.localeCompare(r);
        });
        otherValues.sort(function (_a, _b) {
            var l = _a[0];
            var r = _b[0];
            return l.localeCompare(r);
        });
        if (selfValues.length !== otherValues.length)
            return false;
        for (var i = 0; i < selfValues.length; i++) {
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            var _a = selfValues[i], left = _a[1];
            // eslint-disable-next-line @typescript-eslint/no-non-null-assertion
            var _b = otherValues[i], right = _b[1];
            if (!equals(left, right))
                return false;
        }
        return true;
    }
    return self === other;
};
exports.default = equals;
