"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
var hash_1 = require("../math/hash");
var hash = function (hashable, seed) {
    if (seed === void 0) { seed = 0; }
    var _hash = (0, hash_1.cyrb53)(seed);
    if (hashable === null)
        return 17;
    if (hashable === undefined)
        return 31;
    if (typeof hashable === 'string')
        return _hash(hashable);
    if (typeof hashable === 'bigint' || typeof hashable === 'number')
        return _hash("".concat(hashable));
    if (typeof hashable === 'boolean')
        return _hash("".concat(+hashable)); // +true = 1; +false = 0;
    if (Array.isArray(hashable)) {
        return hashable.reduce(function (agr, next) { return 17 * agr + hash(next, _hash("".concat(seed))); }, 17);
    }
    var values = Object.entries(hashable);
    values.sort(function (_a, _b) {
        var l = _a[0];
        var r = _b[0];
        return l.localeCompare(r);
    });
    return values.reduce(function (agr, _a) {
        var v = _a[1];
        return 17 * agr + hash(v, _hash("".concat(seed)));
    }, 17);
};
exports.default = hash;
